;********************************* 
;* Title : GUI pour MessageRequesterPerso
;* Permet de crer ses propres MessageRequester avec la Police qui va bien grace  une GUI.
;* Author : GeoTrouvpatou aka El Konkonbre Masqued 
;* Date : 12/06/2011 
;* Compatibility 
;* Windows x86 [?] | Windows x64 [Ok] 
;* Linux x86 [?] | Linux x64 [Ok] 
;* MacOs PPC [?] | MacOs intel [?] 
;* Unicode [?] 
;* Demo version [Ok] 
;********************************* 
XIncludeFile "gui.pbi"

Procedure Open_Window_Main()
      Protected menu.i
      If OpenWindow(#WINDOW_Main, 300, 300, 750, 460, "Crateur de MessageRequester.",  #PB_Window_MinimizeGadget | #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered )
            
            menu = CreateImageMenu(#MENU_WindowMain, WindowID(#WINDOW_Main))
            If menu
                  
                  MenuTitle("Fichier")
                  MenuItem(#MENU_Quitter, "Quitter", CatchImage(#IMAGE_iconeQuit, ?iconeQuit))
                  
                  MenuTitle("Actions")
                  MenuItem(#MENU_Importer, "Importer", CatchImage(#IMAGE_iconeImport, ?iconeImport))
                  MenuItem(#MENU_ValeursParDefaut, "Remettre les valeurs par dfaut", CatchImage(#IMAGE_iconeDefaut, ?iconeDefaut))
                  
                  MenuTitle("A propos")
                  MenuItem(#MENU_Site,    "Site internet", CatchImage(#IMAGE_iconeUrl, ?iconeUrl))
                  MenuItem(#MENU_APropos,    "A propos", CatchImage(#IMAGE_iconeAPropos, ?iconeAPropos))
            EndIf
            
            
            If CreateStatusBar(#STATUT_BAR, WindowID(#WINDOW_Main))
                  AddStatusBarField(200)
                  
                  StatusBarText(#STATUT_BAR, 0, "Retour de fonction : ")
                  
            EndIf
            
            
            
            Frame3DGadget(#FRAME3D_ProprieteFenetre, 10, 10, 346, 160, "Proprits de la fentre")
            SetGadgetFont(#FRAME3D_ProprieteFenetre, FontID(fontIdTrebuchet8))
            
            TextGadget(#TEXT_NomFenetre, 26, 34, 100, 16, "Nom de la fentre")
            StringGadget(#STRING_NomFenetre, 140, 30, 178, 22, "Information.")
            Open_MessageRequester\NomFenetre$ = "Information."
            
            TextGadget(#TEXT_NomNewList, 26, 62, 104, 16, "Nom de la NewList")
            StringGadget(#STRING_NomNewList, 140, 58, 178, 22, "Message") 
            Open_MessageRequester\NomNewList$ = "Message"
            ButtonImageGadget(#BUTTON_IMAGE_NomNewListHelp, 322, 55, 28, 28, CatchImage(#IMAGE_imageHelp_NNLH, ?imageHelp))
            
            TextGadget(#TEXT_Width, 110, 88, 110, 16, "Largeur de la fentre")
            StringGadget(#STRING_Width, 226, 84, 40, 22, "650") 
            TextGadget(#TEXT_Height, 110, 114, 110, 16, "Hauteur de la fentre")
            StringGadget(#STRING_Height, 226, 110, 40, 22, "250")
            Open_MessageRequester\Width = 650
            Open_MessageRequester\Height = 250
            
            TextGadget(#TEXT_LesBoutons, 88, 142, 68, 16, "Les boutons")
            ComboBoxGadget(#COMBO_BOX_LesBoutons, 160, 135, 122, 28)
            AddGadgetItem(#COMBO_BOX_LesBoutons, -1, "Oui|Non")
            AddGadgetItem(#COMBO_BOX_LesBoutons, -1, "Oui|Non|Annuler")
            AddGadgetItem(#COMBO_BOX_LesBoutons, -1, "OK")
            SetGadgetState(#COMBO_BOX_LesBoutons, 0)
            Open_MessageRequester\BoutonsActions$ = "Oui|Non"
            
            
            Frame3DGadget(#FRAME3D_Icone, 370, 10, 370, 160, "Icne")
            SetGadgetFont(#FRAME3D_Icone, FontID(fontIdTrebuchet8))
            
            ButtonImageGadget(#BUTTON_IMAGE_Exclamation, 388, 30, 58, 58, CatchImage(#IMAGE_iconeExclamation, ?iconeExclamation))
            ButtonImageGadget(#BUTTON_IMAGE_Info, 458, 30, 58, 58, CatchImage(#IMAGE_iconeInformation, ?iconeInformation))
            ButtonImageGadget(#BUTTON_IMAGE_Interrogation, 528, 30, 58, 58, CatchImage(#IMAGE_iconeQuestion, ?iconeQuestion))
            ButtonImageGadget(#BUTTON_IMAGE_Stop, 598, 30, 58, 58, CatchImage(#IMAGE_iconeError, ?iconeError))
            ButtonGadget(#BUTTON_AucuneImage, 672, 30, 58, 58, "Aucune Icne", #PB_Button_MultiLine)
            TextGadget(#TEXT_IconeChoisie, 515, 90, 76, 16, "Icne choisie", #PB_Text_Center)
            
            ImageGadget(#IMAGE_IconeChoisieResultat, 528, 110, 58, 58, CatchImage(#IMAGE_iconeAucune, ?iconeAucune)) ; Par dfaut.
            Open_MessageRequester\IdImage = #MRP_iconeAucune
            
            
            Frame3DGadget(#FRAME3D_ProprieteTexte, 10, 176, 730, 57, "Proprits du texte")
            SetGadgetFont(#FRAME3D_ProprieteTexte, FontID(fontIdTrebuchet8))
            
            TextGadget(#TEXT_Police, 21, 201, 40, 16, "Police :")
            ComboBoxGadget(#COMBO_BOX_Police, 68, 196, 126, 28)
            
            CompilerSelect #PB_Compiler_OS   
                  CompilerCase #PB_OS_Windows
                        AddGadgetItem(#COMBO_BOX_Police, -1, "Trebuchet MS")
                        SetGadgetState(#COMBO_BOX_Police, 0)
                        Open_MessageRequester\PoliceNom$ = "Trebuchet MS"
                        
                  CompilerCase #PB_OS_Linux  ; Sans  Monospace
                        AddGadgetItem(#COMBO_BOX_Police, -1, "FreeSans")
                        SetGadgetState(#COMBO_BOX_Police, 0)
                        Open_MessageRequester\PoliceNom$ = "FreeSans"
                        
            CompilerEndSelect
            
            TextGadget(#TEXT_PoliceTaille, 220, 201, 38, 16, "Taille :")
            ComboBoxGadget(#COMBO_BOX_PoliceTaille, 260, 196, 60, 28)
            AddGadgetItem(#COMBO_BOX_PoliceTaille, -1, "8")
            AddGadgetItem(#COMBO_BOX_PoliceTaille, -1, "9")
            AddGadgetItem(#COMBO_BOX_PoliceTaille, -1, "10")
            AddGadgetItem(#COMBO_BOX_PoliceTaille, -1, "11")
            AddGadgetItem(#COMBO_BOX_PoliceTaille, -1, "12")
            AddGadgetItem(#COMBO_BOX_PoliceTaille, -1, "14")
            AddGadgetItem(#COMBO_BOX_PoliceTaille, -1, "16")
            SetGadgetState(#COMBO_BOX_PoliceTaille, 2)
            Open_MessageRequester\PoliceTaille = 10
            
            TextGadget(#TEXT_HauteurDeLigne, 350, 201, 92, 16, "Hauteur de ligne :")
            SpinGadget(#SPIN_HauteurDeLigne, 444, 196, 50, 24, 0, 50)
            SetGadgetState (#SPIN_HauteurDeLigne, 18)
            SetGadgetText(#SPIN_HauteurDeLigne, "18") ; Dfinit la valeure initiale
            Open_MessageRequester\HauteurDeLigne = 18
            ButtonImageGadget(#BUTTON_IMAGE_HauteurDeLigneHelp, 498, 196, 28, 28, CatchImage(#IMAGE_imageHelp_HDL, ?imageHelp))
            
            CheckBoxGadget(#CHECK_BOX_Debug, 565, 201, 140, 22, "Activer le mode Debug.")
            ButtonImageGadget(#BUTTON_IMAGE_DebugHelp, 704, 196, 28, 28, CatchImage(#IMAGE_imageHelp_DH, ?imageHelp))
            
            
            EditorGadget(#EDITOR_MessageRequester, 10, 240, 730, 140)
            AddGadgetItem(#EDITOR_MessageRequester, -1, "Voici un petit message pour tester la cration d'un MessageRequester") 
            AddGadgetItem(#EDITOR_MessageRequester, -1, "offrant la possibilit de mettre une police personnelle.") 
            
            
            TextGadget(#TEXT_Modal, 12, 388, 116, 16, "Modal par rapport  :") ;, #PB_Text_Border
            StringGadget(#STRING_Modal, 128, 386, 135, 22, "")
            
            ButtonGadget(#BUTTON_Tester, 270, 385, 100, 24, "Tester")
            ButtonGadget(#BUTTON_Generer, 382, 385, 100, 24, "Gnrer")
            
            
            ;-/ Gadget Fonts
            ; SetGadgetFont(#FRAME3D_ProprieteFenetre, FontID(fontIdTrebuchet8))
            SetGadgetFont(#TEXT_NomFenetre, FontID(fontIdTrebuchet8))
            SetGadgetFont(#STRING_NomFenetre, FontID(fontIdTrebuchet8))
            SetGadgetFont(#TEXT_NomNewList, FontID(fontIdTrebuchet8))
            SetGadgetFont(#STRING_NomNewList, FontID(fontIdTrebuchet8))
            
            SetGadgetFont(#TEXT_Width, FontID(fontIdTrebuchet8))
            SetGadgetFont(#STRING_Width, FontID(fontIdTrebuchet8))
            SetGadgetFont(#TEXT_Height, FontID(fontIdTrebuchet8))
            SetGadgetFont(#STRING_Height, FontID(fontIdTrebuchet8))
            
            SetGadgetFont(#TEXT_LesBoutons, FontID(fontIdTrebuchet8))
            SetGadgetFont(#COMBO_BOX_LesBoutons, FontID(fontIdTrebuchet8))
            
            ; SetGadgetFont(#FRAME3D_Icone, FontID(fontIdTrebuchet8))
            SetGadgetFont(#BUTTON_AucuneImage, FontID(fontIdTrebuchet8))
            SetGadgetFont(#TEXT_IconeChoisie, FontID(fontIdTrebuchet8))
            
            ; SetGadgetFont(#FRAME3D_ProprieteTexte, FontID(fontIdTrebuchet8))
            SetGadgetFont(#TEXT_Police, FontID(fontIdTrebuchet8))
            SetGadgetFont(#COMBO_BOX_Police, FontID(fontIdTrebuchet8))
            SetGadgetFont(#TEXT_PoliceTaille, FontID(fontIdTrebuchet8))
            SetGadgetFont(#COMBO_BOX_PoliceTaille, FontID(fontIdTrebuchet8))
            SetGadgetFont(#TEXT_HauteurDeLigne, FontID(fontIdTrebuchet8))
            SetGadgetFont(#SPIN_HauteurDeLigne, FontID(fontIdTrebuchet8))
            
            SetGadgetFont(#CHECK_BOX_Debug, FontID(fontIdTrebuchet8))
            SetGadgetFont(#BUTTON_IMAGE_DebugHelp, FontID(fontIdTrebuchet8))
            
            SetGadgetFont(#EDITOR_MessageRequester, FontID(fontIdTrebuchet10))
            
            SetGadgetFont(#TEXT_Modal, FontID(fontIdTrebuchet8))
            SetGadgetFont(#STRING_Modal, FontID(fontIdTrebuchet8))
            
            SetGadgetFont(#BUTTON_Tester, FontID(fontIdTrebuchet10))
            SetGadgetFont(#BUTTON_Generer, FontID(fontIdTrebuchet10))
            
      EndIf
EndProcedure

Open_Window_Main()


;{
;- >>>>>>>>>>>> Ma loop
Repeat
      evenement = WaitWindowEvent()
      
      ;->> Evnements Menu
      If evenement = #PB_Event_Menu
            Select EventMenu()
                        
                  Case #MENU_Importer 
                        MessageRequesterImporter()
                        
                  Case #MENU_ValeursParDefaut
                        MessageRequesterValeursParDefaut()
                        
                  Case #MENU_Quitter 
                        quit = 1
                        
                  Case #MENU_Site
                        OuvrirNavigateurParDefaut("http://actif-video.chez-alice.fr/")       
                        
                  Case #MENU_APropos   
                        DisableWindow(#WINDOW_Main, 1)
                        CompilerSelect #PB_Compiler_OS
                              CompilerCase #PB_OS_Windows
                                    MessageRequesterPerso(450, 180, "A propos.", MRP_APropos$(), "Trebuchet MS", 10, 18, 0, #MRP_iconeInformation, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                                    
                              CompilerCase #PB_OS_Linux
                                    MessageRequesterPerso(450, 180, "A propos.", MRP_APropos$(), "FreeSans", 10, 18, 0, #MRP_iconeInformation, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                                    
                        CompilerEndSelect
                        DisableWindow(#WINDOW_Main, 0)
                        StickyWindow(#WINDOW_Main, 1)
                        StickyWindow(#WINDOW_Main, 0)
                        
            EndSelect
      EndIf
      
      
      
      ;->> Evnements Window
      If evenement = #PB_Event_CloseWindow
            Select EventWindow() 
                        
                  Case #Window_Main
                        quit = 1     
                        
            EndSelect    
      EndIf
      
      
      
      ;->> Evnements Boutons (Gadgets en gnral)
      If evenement =  #PB_Event_Gadget
            Select EventGadget()
                        
                  Case #STRING_NomFenetre
                        Open_MessageRequester\NomFenetre$ = GetGadgetText(#STRING_NomFenetre)
                        
                        
                  Case #STRING_NomNewList
                        Open_MessageRequester\NomNewList$ = GetGadgetText(#STRING_NomNewList)
                        
                        
                  Case #BUTTON_IMAGE_NomNewListHelp
                        DisableWindow(#WINDOW_Main, 1)
                        CompilerSelect #PB_Compiler_OS
                              CompilerCase #PB_OS_Windows
                                    MessageRequesterPerso(660, 240, "Information.", MRP_NomNewList$(), "Trebuchet MS", 10, 18, 0, #MRP_iconeInformation, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                                    
                              CompilerCase #PB_OS_Linux
                                    MessageRequesterPerso(660, 240, "Information.", MRP_NomNewList$(), "FreeSans", 10, 18, 0, #MRP_iconeInformation, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                                    
                        CompilerEndSelect
                        DisableWindow(#WINDOW_Main, 0)
                        StickyWindow(#WINDOW_Main, 1)
                        StickyWindow(#WINDOW_Main, 0)
                        
                        
                  Case #STRING_Width
                        Open_MessageRequester\Width = Val(GetGadgetText(#STRING_Width))
                        
                        
                  Case #STRING_Height
                        Open_MessageRequester\Height = Val(GetGadgetText(#STRING_Height))
                        
                        
                  Case #COMBO_BOX_LesBoutons
                        Open_MessageRequester\BoutonsActions$ = GetGadgetText(#COMBO_BOX_LesBoutons)
                        Debug "Open_MessageRequester\BoutonsActions$ >>>> "+ Open_MessageRequester\BoutonsActions$
                        ; > OK autorise la croix rouge de fermeture de la fentre et vaut 1 comme en appuyant sur Ok
                        If Open_MessageRequester\BoutonsActions$ = "OK" Or Open_MessageRequester\BoutonsActions$ = "Oui|Non|Annuler"
                              flags = #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered
                              flags$ = "#PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered"
                              Debug "flags = "+ Str(flags)
                        EndIf
                        ; > Oui et Non bloque la croix rouge de fermeture de la fentre
                        If Open_MessageRequester\BoutonsActions$ = "Oui|Non"
                              flags = #PB_Window_TitleBar | #PB_Window_ScreenCentered
                              flags$ = "#PB_Window_TitleBar | #PB_Window_ScreenCentered"
                              Debug "flags = "+ Str(flags)
                        EndIf
                        
                        
                  Case #COMBO_BOX_Police
                        Open_MessageRequester\PoliceNom$ = GetGadgetText(#COMBO_BOX_Police)
                        
                        CompilerSelect #PB_Compiler_OS   
                              CompilerCase #PB_OS_Windows
                                    If Open_MessageRequester\PoliceNom$ = "Trebuchet MS"
                                          policeWindows$ = "Trebuchet MS"
                                          policeLinux$ = "FreeSans"
                                          
                                    EndIf
                                    
                              CompilerCase #PB_OS_Linux 
                                    If Open_MessageRequester\PoliceNom$ = "FreeSans"
                                          policeWindows$ = "Trebuchet MS"
                                          policeLinux$ = "FreeSans"
                                    EndIf
                                    
                        CompilerEndSelect
                        
                        
                  Case #COMBO_BOX_PoliceTaille
                        Open_MessageRequester\PoliceTaille = Val(GetGadgetText(#COMBO_BOX_PoliceTaille))
                        
                        
                  Case #SPIN_HauteurDeLigne   
                        SetGadgetText(#SPIN_HauteurDeLigne, Str(GetGadgetState(#SPIN_HauteurDeLigne)))
                        Open_MessageRequester\HauteurDeLigne = GetGadgetState(#SPIN_HauteurDeLigne)
                        
                        
                  Case  #BUTTON_IMAGE_HauteurDeLigneHelp
                        DisableWindow(#WINDOW_Main, 1)
                        CompilerSelect #PB_Compiler_OS
                              CompilerCase #PB_OS_Windows
                                    MessageRequesterPerso(420, 190, "Information.", MRP_HauteurDeLigne$(), "Trebuchet MS", 10, 18, 0, #MRP_iconeInformation, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                                    
                              CompilerCase #PB_OS_Linux
                                    MessageRequesterPerso(420, 190, "Information.", MRP_HauteurDeLigne$(), "FreeSans", 10, 18, 0, #MRP_iconeInformation, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                                    
                        CompilerEndSelect
                        DisableWindow(#WINDOW_Main, 0)
                        StickyWindow(#WINDOW_Main, 1)
                        StickyWindow(#WINDOW_Main, 0)
                        
                        
                  Case #CHECK_BOX_Debug     
                        If GetGadgetState(#CHECK_BOX_Debug)
                              Open_MessageRequester\ModeDebug = 1
                        Else
                              Open_MessageRequester\ModeDebug = 0
                        EndIf 
                        
                        
                  Case #BUTTON_IMAGE_DebugHelp
                        DisableWindow(#WINDOW_Main, 1)
                        CompilerSelect #PB_Compiler_OS
                              CompilerCase #PB_OS_Windows
                                    MessageRequesterPerso(540, 150, "Information.", MRP_ActiverModeDebug$(), "Trebuchet MS", 10, 18, 0, #MRP_iconeInformation, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                                    
                              CompilerCase #PB_OS_Linux
                                    MessageRequesterPerso(540, 150, "Information.", MRP_ActiverModeDebug$(), "FreeSans", 10, 18, 0, #MRP_iconeInformation, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                                    
                        CompilerEndSelect
                        DisableWindow(#WINDOW_Main, 0)
                        StickyWindow(#WINDOW_Main, 1)
                        StickyWindow(#WINDOW_Main, 0)
                        
                        
                        ; catch 10  14 
                  Case #BUTTON_IMAGE_Exclamation
                        Open_MessageRequester\IdImage = #MRP_iconeExclamation
                        SetGadgetState(#IMAGE_IconeChoisieResultat, CatchImage(#IMAGE_iconeExclamation, ?iconeExclamation))
                        iconeAvertissement$ = "#MRP_iconeExclamation"
                        
                        
                  Case #BUTTON_IMAGE_Info
                        Open_MessageRequester\IdImage = #MRP_iconeInformation
                        SetGadgetState(#IMAGE_IconeChoisieResultat, CatchImage(#IMAGE_iconeInformation, ?iconeInformation))
                        iconeAvertissement$ = "#MRP_iconeInformation"
                        
                        
                  Case #BUTTON_IMAGE_Interrogation
                        Open_MessageRequester\IdImage = #MRP_iconeQuestion
                        SetGadgetState(#IMAGE_IconeChoisieResultat, CatchImage(#IMAGE_iconeQuestion, ?iconeQuestion))
                        iconeAvertissement$ = "#MRP_iconeQuestion"
                        
                        
                  Case #BUTTON_IMAGE_Stop
                        Open_MessageRequester\IdImage = #MRP_iconeError
                        SetGadgetState(#IMAGE_IconeChoisieResultat, CatchImage(#IMAGE_iconeError, ?iconeError))
                        iconeAvertissement$ = "#MRP_iconeError"
                        
                        
                  Case #BUTTON_AucuneImage
                        Open_MessageRequester\IdImage = #MRP_iconeAucune
                        SetGadgetState(#IMAGE_IconeChoisieResultat, CatchImage(#IMAGE_iconeAucune, ?iconeAucune))
                        iconeAvertissement$ = "#MRP_iconeAucune"
                        
                        
                  Case #STRING_Modal
                        Open_MessageRequester\Modal$ = GetGadgetText(#STRING_Modal)
                        
                        
                  Case #BUTTON_Tester
                        MessageRequesterTester()
                        
                        
                  Case #BUTTON_Generer
                        MessageRequesterBuild()
                        
            EndSelect
      EndIf
      
Until quit = 1
;}
;EndProcedure



Procedure MessageRequesterTester()
      Protected nbGadgetItems.b, i.i
      Protected retourProcedure.i
      
      ; Debug "flags dans MessageRequesterTester() = "+ flags$
      
      ; On rinitialise la Statut bar
      StatusBarText(#STATUT_BAR, 0, "Retour de fonction : ")
      
      
      ; Permet de mettre chaque ligne du message dans une liste.
      NewList MonTexte$()
      nbGadgetItems = CountGadgetItems(#EDITOR_MessageRequester)
      Debug "nbGadgetItems "+ Str(nbGadgetItems)
      
      For i = 0 To nbGadgetItems - 1
            AddElement(MonTexte$()) : MonTexte$() = GetGadgetItemText(#EDITOR_MessageRequester, i)
      Next i  
      ; Debug "==============================="
      ; Debug Open_MessageRequester\PoliceNom$
      ; Debug Open_MessageRequester\PoliceTaille
      ; Debug "==============================="
      DisableWindow(#WINDOW_Main, 1)
      retourProcedure = MessageRequesterPerso(Open_MessageRequester\Width, Open_MessageRequester\Height, Open_MessageRequester\NomFenetre$, MonTexte$(), Open_MessageRequester\PoliceNom$, Open_MessageRequester\PoliceTaille, Open_MessageRequester\HauteurDeLigne, Open_MessageRequester\ModeDebug, Open_MessageRequester\IdImage, Open_MessageRequester\BoutonsActions$, flags)
      DisableWindow(#WINDOW_Main, 0)
      
      
      ;Debug "retourProcedure : "+ Str(retourProcedure)
      StatusBarText(#STATUT_BAR, 0, "Retour de fonction : "+ Str(retourProcedure))
      ;
      StickyWindow(#WINDOW_Main, 1)
      StickyWindow(#WINDOW_Main, 0)
EndProcedure


Procedure MessageRequesterBuild()
      Protected build$
      Protected nbGadgetItems.b, i.i
      
      build$ = "XIncludeFile("+Chr(34)+"libRequesterPerso.pbi"+Chr(34)+")"+ #EOL$ + #EOL$
      
      ; Permet de mettre chaque ligne du message dans une liste.
      ;build$ + "NewList Message$()"+ #EOL$
      build$ + "Global NewList "+ Open_MessageRequester\NomNewList$ +"$()"+ #EOL$  
      
      nbGadgetItems = CountGadgetItems(#EDITOR_MessageRequester)
      Debug "nbGadgetItems "+ Str(nbGadgetItems)
      For i = 0 To nbGadgetItems - 1
            build$ + "AddElement("+Open_MessageRequester\NomNewList$ +"$()) : "+Open_MessageRequester\NomNewList$ +"$() = "+Chr(34)+ NettoyerTexte(GetGadgetItemText(#EDITOR_MessageRequester, i)) +Chr(34)+ #EOL$
      Next 
      
      build$ + "" + #EOL$
      
      build$ + "Define resultat.i"+ #EOL$ + #EOL$    
      
      If Open_MessageRequester\Modal$ <> ""
            build$ + "; DisableWindow("+ Open_MessageRequester\Modal$ +", 1)"+ #EOL$
      EndIf
      
      build$ + "CompilerSelect #PB_Compiler_OS"+ #EOL$
      build$ + "      CompilerCase #PB_OS_Windows"+ #EOL$
      
      build$ + "            resultat = MessageRequesterPerso("+ Str(Open_MessageRequester\Width) +", "+ Str(Open_MessageRequester\Height) +", "+Chr(34)+ Open_MessageRequester\NomFenetre$ +Chr(34)+", "+Open_MessageRequester\NomNewList$ +"$(), "+Chr(34)+ policeWindows$ +Chr(34)+", "+ Str(Open_MessageRequester\PoliceTaille) +", "+ Str(Open_MessageRequester\HauteurDeLigne) +", "+ Str(Open_MessageRequester\ModeDebug) +", "+ iconeAvertissement$ +", "+Chr(34)+ Open_MessageRequester\BoutonsActions$ +Chr(34)+", "+ flags$ +")"+ #EOL$ + #EOL$
      
      build$ + "      CompilerCase #PB_OS_Linux"+ #EOL$       
      
      build$ + "            resultat = MessageRequesterPerso("+ Str(Open_MessageRequester\Width) +", "+ Str(Open_MessageRequester\Height) +", "+Chr(34)+ Open_MessageRequester\NomFenetre$ +Chr(34)+", "+Open_MessageRequester\NomNewList$ +"$(), "+Chr(34)+ policeLinux$ +Chr(34)+", "+ Str(Open_MessageRequester\PoliceTaille) +", "+ Str(Open_MessageRequester\HauteurDeLigne) +", "+ Str(Open_MessageRequester\ModeDebug) +", "+ iconeAvertissement$ +", "+Chr(34)+ Open_MessageRequester\BoutonsActions$ +Chr(34)+", "+ flags$ +")"+ #EOL$ + #EOL$
      
      build$ + "CompilerEndSelect"+ #EOL$
      
      If Open_MessageRequester\Modal$ <> ""
            build$ + "; DisableWindow("+ Open_MessageRequester\Modal$ +", 0)"+ #EOL$
            build$ + "; StickyWindow("+ Open_MessageRequester\Modal$ +", 1)"+ #EOL$
            build$ + "; StickyWindow("+ Open_MessageRequester\Modal$ +", 0)"+ #EOL$
      EndIf
      
      build$ + #EOL$
      build$ + "Debug "+Chr(34)+"Sortie finale : "+Chr(34)+"+ Str(resultat)"
      
      SetClipboardText(build$)
      
      DisableWindow(#WINDOW_Main, 1)
      CompilerSelect #PB_Compiler_OS
            CompilerCase #PB_OS_Windows
                  MessageRequesterPerso(350, 120, "Information.", MRP_CodeDansPressePapier$(), "Trebuchet MS", 10, 18, 0, #MRP_iconeInformation, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                  
            CompilerCase #PB_OS_Linux
                  MessageRequesterPerso(350, 120, "Information.", MRP_CodeDansPressePapier$(), "FreeSans", 10, 18, 0, #MRP_iconeInformation, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                  
      CompilerEndSelect
      DisableWindow(#WINDOW_Main, 0)
      StickyWindow(#WINDOW_Main, 1)
      StickyWindow(#WINDOW_Main, 0)
      
      MessageRequesterSauvegarder()
EndProcedure


Procedure MessageRequesterSauvegarder()
      Protected enregistrement.b, nbLigneEditorMessageRequester.i, i.i
      
      
      nbLigneEditorMessageRequester = CountGadgetItems(#EDITOR_MessageRequester)
      ;Debug nbLigneEditorMessageRequester
      
      Debug GetGadgetText(#STRING_NomNewList) +".prefs"
      
      ; Le fichier existe dj donc on demande si l'on veut l'craser.
      If FileSize(GetGadgetText(#STRING_NomNewList) +".prefs") > 0 ; log-erreur.txt
            
            DisableWindow(#WINDOW_Main, 1)
            CompilerSelect #PB_Compiler_OS
                  CompilerCase #PB_OS_Windows
                        enregistrement = MessageRequesterPerso(380, 165, "Attention.", MRP_FichierPrefsExisteDeja$(), "Trebuchet MS", 10, 18, 0, #MRP_iconeExclamation, "Oui|Non", #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                        
                  CompilerCase #PB_OS_Linux
                        enregistrement = MessageRequesterPerso(380, 165, "Attention.", MRP_FichierPrefsExisteDeja$(), "FreeSans", 10, 18, 0, #MRP_iconeExclamation, "Oui|Non", #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                        
            CompilerEndSelect
            DisableWindow(#WINDOW_Main, 0)
            StickyWindow(#WINDOW_Main, 1)
            StickyWindow(#WINDOW_Main, 0)
            
            Debug "FichierPrefsExisteDeja Voulez-vous craser [Oui = 6 - Non = 7] : "+ Str(enregistrement)
            
      Else
            ; Si le fichier n'existe pas encore
            
            DisableWindow(#WINDOW_Main, 1)
            CompilerSelect #PB_Compiler_OS
                  CompilerCase #PB_OS_Windows
                        enregistrement = MessageRequesterPerso(380, 165, "Question.", MRP_FichierPrefsExistePasEncore$(), "Trebuchet MS", 10, 18, 0, #MRP_iconeQuestion, "Oui|Non", #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                        
                  CompilerCase #PB_OS_Linux
                        enregistrement = MessageRequesterPerso(380, 165, "Question.", MRP_FichierPrefsExistePasEncore$(), "FreeSans", 10, 18, 0, #MRP_iconeQuestion, "Oui|Non", #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                        
            CompilerEndSelect
            DisableWindow(#WINDOW_Main, 0)
            StickyWindow(#WINDOW_Main, 1)
            StickyWindow(#WINDOW_Main, 0)
      EndIf
      
      If enregistrement = #MRP_Yes ; Ou #PB_MessageRequester_Yes
            
            If CreatePreferences(GetGadgetText(#STRING_NomNewList) +".prefs")
                  PreferenceGroup("ProprietesFenetre")
                  ;             WritePreferenceString("FenetreNom", GetGadgetText(#STRING_NomFenetre))
                  ;             WritePreferenceString("NomNewList", GetGadgetText(#STRING_NomNewList))
                  ;             WritePreferenceString("FenetreLargeur", GetGadgetText(#STRING_Width))
                  ;             WritePreferenceString("FenetreHauteur", GetGadgetText(#STRING_Height))
                  
                  WritePreferenceString("FenetreNom", Open_MessageRequester\NomFenetre$)
                  WritePreferenceString("NomNewList", Open_MessageRequester\NomNewList$)
                  WritePreferenceLong ("FenetreLargeur", Open_MessageRequester\Width)
                  WritePreferenceLong ("FenetreHauteur", Open_MessageRequester\Height)
                  WritePreferenceString("FenetreBoutons", Open_MessageRequester\BoutonsActions$)
                  WritePreferenceString("Modal", Open_MessageRequester\Modal$)
                  
                  PreferenceComment("")
                  PreferenceGroup("Icone")
                  
                  WritePreferenceString("IconeChoisie", iconeAvertissement$)
                  
                  
                  PreferenceComment("")
                  PreferenceGroup("ProprietesTexte")
                  
                  WritePreferenceString("PoliceNom", Open_MessageRequester\PoliceNom$)
                  WritePreferenceLong ("PoliceTaille", Open_MessageRequester\PoliceTaille)
                  WritePreferenceLong ("HauteurDeLigne", Open_MessageRequester\HauteurDeLigne)
                  
                  
                  PreferenceComment("")
                  PreferenceGroup("Message")
                  For i = 0 To (nbLigneEditorMessageRequester - 1)
                        WritePreferenceString("Data_"+ Str(i), GetGadgetItemText(#EDITOR_MessageRequester, i))
                  Next i
                  
                  ClosePreferences()
                  
            Else
                  ; Remettre valeurs par dfaut
                  
                  DisableWindow(#WINDOW_Main, 1)
                  CompilerSelect #PB_Compiler_OS
                        CompilerCase #PB_OS_Windows
                              MessageRequesterPerso(410, 150, "Erreur.", MRP_FichierPrefsSaveFail$(), "Trebuchet MS", 10, 18, 0, #MRP_iconeError, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                              
                        CompilerCase #PB_OS_Linux
                              MessageRequesterPerso(410, 150, "Erreur.", MRP_FichierPrefsSaveFail$(), "FreeSans", 10, 18, 0, #MRP_iconeError, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                              
                  CompilerEndSelect
                  DisableWindow(#WINDOW_Main, 0)
                  StickyWindow(#WINDOW_Main, 1)
                  StickyWindow(#WINDOW_Main, 0)
                  
            EndIf     
            
      EndIf      
EndProcedure


Procedure MessageRequesterValeursParDefaut()
      Protected remettreValeurParDefaut.b
      
      DisableWindow(#WINDOW_Main, 1)
      CompilerSelect #PB_Compiler_OS
            CompilerCase #PB_OS_Windows
                  remettreValeurParDefaut = MessageRequesterPerso(450, 150, "Question ?", MRP_RemettreValeurParDefaut$(), "Trebuchet MS", 10, 18, 0, #MRP_iconeQuestion, "Oui|Non", #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                  
            CompilerCase #PB_OS_Linux
                  remettreValeurParDefaut = MessageRequesterPerso(450, 150, "Question ?", MRP_RemettreValeurParDefaut$(), "FreeSans", 10, 18, 0, #MRP_iconeQuestion, "Oui|Non", #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                  
      CompilerEndSelect
      DisableWindow(#WINDOW_Main, 0)
      StickyWindow(#WINDOW_Main, 1)
      StickyWindow(#WINDOW_Main, 0)
      
      
      If remettreValeurParDefaut = #MRP_Yes ; Ou #PB_MessageRequester_Yes
            
            Open_MessageRequester\NomFenetre$ = "Information."
            SetGadgetText(#STRING_NomFenetre, "Information.")
            Debug Open_MessageRequester\NomFenetre$
            
            Open_MessageRequester\NomNewList$ = "Message"
            SetGadgetText(#STRING_NomNewList, "Message")
            Debug Open_MessageRequester\NomNewList$
            
            Open_MessageRequester\Width = 650
            SetGadgetText(#STRING_Width, Str(650))
            Debug Open_MessageRequester\Width
            
            Open_MessageRequester\Height = 250
            SetGadgetText(#STRING_Height, Str(250))
            Debug Open_MessageRequester\Height
            
            Open_MessageRequester\BoutonsActions$ = "Oui|Non"
            SetGadgetText(#COMBO_BOX_LesBoutons, "Oui|Non")
            Debug Open_MessageRequester\BoutonsActions$
            
            Open_MessageRequester\Modal$ = ""
            SetGadgetText(#STRING_Modal, "")
            Debug Open_MessageRequester\Modal$
            
            
            Open_MessageRequester\IdImage = #MRP_iconeAucune
            SetGadgetState(#IMAGE_IconeChoisieResultat, CatchImage(#IMAGE_iconeAucune, ?iconeAucune)) 
            Debug Open_MessageRequester\IdImage
            
            
            CompilerSelect #PB_Compiler_OS 
                  CompilerCase #PB_OS_Windows
                        Open_MessageRequester\PoliceNom$ = "Trebuchet MS"
                        SetGadgetText(#COMBO_BOX_Police, "Trebuchet MS")
                        
                  CompilerCase #PB_OS_Linux  
                        Open_MessageRequester\PoliceNom$ = "FreeSans"
                        SetGadgetText(#COMBO_BOX_Police, "FreeSans") 
                        
            CompilerEndSelect
            Debug Open_MessageRequester\PoliceNom$
            
            Open_MessageRequester\PoliceTaille = 10
            SetGadgetText(#COMBO_BOX_PoliceTaille, Str(10))
            Debug Open_MessageRequester\PoliceTaille
            
            Open_MessageRequester\HauteurDeLigne = 18
            SetGadgetText(#SPIN_HauteurDeLigne, Str(18))
            Debug Open_MessageRequester\HauteurDeLigne
            
            Open_MessageRequester\ModeDebug = 0
            SetGadgetState(#CHECK_BOX_Debug, 0)
            Debug Open_MessageRequester\ModeDebug
            
            ClearGadgetItems(#EDITOR_MessageRequester)
      EndIf
      
EndProcedure


Procedure MessageRequesterImporter()
      Protected nomFichier$
      
      nomFichier$ = OpenFileRequester("Choisissez un fichier  importer", "", "Fichiers Prefs|*.prefs", 0)
      Debug "NomFichier$"+ NomFichier$
      
      If nomFichier$ <> ""
            If OpenPreferences(nomFichier$)
                  
                  ; On efface le texte dans l'editor uniquement si l'on a import quelque chose.
                  ClearGadgetItems(#EDITOR_MessageRequester)
                  
                  PreferenceGroup("ProprietesFenetre")
                  Debug ReadPreferenceString("FenetreNom", "Information.")
                  Debug ReadPreferenceString("NomNewList", "Message")
                  Debug ReadPreferenceLong ("FenetreLargeur", 650)
                  Debug ReadPreferenceLong ("FenetreHauteur", 250)
                  Debug ReadPreferenceString("FenetreBoutons", "OK")
                  Debug ReadPreferenceString("Modal", "OK")
                  
                  SetGadgetText(#STRING_NomFenetre, ReadPreferenceString("FenetreNom", "Information."))
                  SetGadgetText(#STRING_NomNewList, ReadPreferenceString("NomNewList", "Message"))
                  SetGadgetText(#STRING_Width, Str(ReadPreferenceLong ("FenetreLargeur", 650)))
                  SetGadgetText(#STRING_Height, Str(ReadPreferenceLong ("FenetreHauteur", 250)))
                  
                  ;SetGadgetText(#STRING_NomFenetre, ReadPreferenceString("FenetreBoutons", "OK"))
                  ;SetGadgetState(#COMBO_BOX_LesBoutons, 0)
                  SetGadgetText(#COMBO_BOX_LesBoutons, ReadPreferenceString("FenetreBoutons", "OK"))
                  SetGadgetText(#STRING_Modal, ReadPreferenceString("Modal", ""))
                  
                  ; On injecte les valeurs de prefs dans les variables.
                  Open_MessageRequester\NomFenetre$ = ReadPreferenceString("FenetreNom", "Information.")
                  Open_MessageRequester\NomNewList$ = ReadPreferenceString("NomNewList", "Message")
                  Open_MessageRequester\Width = ReadPreferenceLong ("FenetreLargeur", 650)
                  Open_MessageRequester\Height = ReadPreferenceLong ("FenetreHauteur", 250)
                  Open_MessageRequester\BoutonsActions$ = ReadPreferenceString("FenetreBoutons", "OK")
                  Open_MessageRequester\Modal$ = ReadPreferenceString("Modal", "")
                  
                  PreferenceGroup("Icone")
                  Debug ReadPreferenceString("IconeChoisie", "#MRP_iconeAucune")
                  
                  
                  If ReadPreferenceString("IconeChoisie", "#MRP_iconeAucune") = "#MRP_iconeExclamation"
                        SetGadgetState(#IMAGE_IconeChoisieResultat, CatchImage(#IMAGE_iconeExclamation, ?iconeExclamation)) 
                        Open_MessageRequester\IdImage = #MRP_iconeExclamation
                        iconeAvertissement$ = "#MRP_iconeExclamation"
                        
                  EndIf        
                  
                  
                  If ReadPreferenceString("IconeChoisie", "#MRP_iconeAucune") = "#MRP_iconeInformation"
                        SetGadgetState(#IMAGE_IconeChoisieResultat, CatchImage(#IMAGE_iconeInformation, ?iconeInformation)) 
                        Open_MessageRequester\IdImage = #MRP_iconeInformation
                        iconeAvertissement$ = "#MRP_iconeInformation"
                        
                  EndIf
                  
                  
                  If ReadPreferenceString("IconeChoisie", "#MRP_iconeAucune") = "#MRP_iconeQuestion"
                        SetGadgetState(#IMAGE_IconeChoisieResultat, CatchImage(#IMAGE_iconeQuestion, ?iconeQuestion)) 
                        Open_MessageRequester\IdImage = #MRP_iconeQuestion
                        iconeAvertissement$ = "#MRP_iconeQuestion"
                        
                  EndIf    
                  
                  If ReadPreferenceString("IconeChoisie", "#MRP_iconeAucune") = "#MRP_iconeError"
                        SetGadgetState(#IMAGE_IconeChoisieResultat, CatchImage(#IMAGE_iconeError, ?iconeError)) 
                        Open_MessageRequester\IdImage = #MRP_iconeError
                        iconeAvertissement$ = "#MRP_iconeError"
                        
                  EndIf   
                  
                  If ReadPreferenceString("IconeChoisie", "#MRP_iconeAucune") = "#MRP_iconeAucune" 
                        SetGadgetState(#IMAGE_IconeChoisieResultat, CatchImage(#IMAGE_iconeAucune, ?iconeAucune)) 
                        Open_MessageRequester\IdImage = #MRP_iconeAucune
                        iconeAvertissement$ = "#MRP_iconeAucune"
                        
                  EndIf 
                  
                  
                  PreferenceGroup("ProprietesTexte")
                  
                  CompilerSelect #PB_Compiler_OS 
                        CompilerCase #PB_OS_Windows 
                              If ReadPreferenceString("PoliceNom", "Trebuchet MS") = "FreeSans"
                                    SetGadgetText(#COMBO_BOX_Police, "Trebuchet MS")
                                    Open_MessageRequester\PoliceNom$ = "Trebuchet MS"
                                    
                              EndIf
                              
                        CompilerCase #PB_OS_Linux  
                              If ReadPreferenceString("PoliceNom", "Trebuchet MS") = "Trebuchet MS"
                                    SetGadgetText(#COMBO_BOX_Police, "FreeSans")
                                    Open_MessageRequester\PoliceNom$ = "FreeSans"
                                    
                              EndIf
                              
                  CompilerEndSelect
                  
                  SetGadgetText(#COMBO_BOX_PoliceTaille, Str(ReadPreferenceLong ("PoliceTaille", 10)))
                  SetGadgetText(#SPIN_HauteurDeLigne, Str(ReadPreferenceLong ("HauteurDeLigne", 18)))
                  
                  Open_MessageRequester\PoliceTaille = ReadPreferenceLong ("PoliceTaille", 10)
                  Open_MessageRequester\HauteurDeLigne = ReadPreferenceLong ("HauteurDeLigne", 18)
                  
                  
                  ; --------------------------
                  ; Affichage du message dans l'EditorGadget.
                  ; --------------------------
                  PreferenceGroup("Message")
                  
                  If ExaminePreferenceKeys()
                        While  NextPreferenceKey()
                              AddGadgetItem(#EDITOR_MessageRequester, -1, PreferenceKeyValue())
                              
                        Wend
                        
                  EndIf
                  
                  ClosePreferences()
                  
                  
                  If Open_MessageRequester\BoutonsActions$ = "OK" Or Open_MessageRequester\BoutonsActions$ = "Oui|Non|Annuler"
                        flags = #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered
                        flags$ = "#PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered"
                        Debug "flags = "+ Str(flags)
                  EndIf
                  ; > Oui et Non bloque la croix rouge de fermeture de la fentre
                  If Open_MessageRequester\BoutonsActions$ = "Oui|Non"
                        flags = #PB_Window_TitleBar | #PB_Window_ScreenCentered
                        flags$ = "#PB_Window_TitleBar | #PB_Window_ScreenCentered"
                        Debug "flags = "+ Str(flags)
                  EndIf
                  
            Else
                  
                  DisableWindow(#WINDOW_Main, 1)
                  CompilerSelect #PB_Compiler_OS
                        CompilerCase #PB_OS_Windows
                              MessageRequesterPerso(300, 140, "Erreur.", MRP_ImportationImpossible$(), "Trebuchet MS", 10, 18, 0, #MRP_iconeError, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                              
                        CompilerCase #PB_OS_Linux
                              MessageRequesterPerso(300, 140, "Erreur.", MRP_ImportationImpossible$(), "FreeSans", 10, 18, 0, #MRP_iconeError, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                              
                  CompilerEndSelect
                  DisableWindow(#WINDOW_Main, 0)
                  StickyWindow(#WINDOW_Main, 1)
                  StickyWindow(#WINDOW_Main, 0)
                  
            EndIf
      EndIf
      
EndProcedure


Procedure OuvrirNavigateurParDefaut(page$)
      Protected browser$
      NewList MRP_OpenNavigateurWait$()
      AddElement(MRP_OpenNavigateurWait$())
      MRP_OpenNavigateurWait$() = "Veuillez patienter pendant l'ouverture du navigateur."
      
      CompilerIf #PB_Compiler_OS = #PB_OS_Windows
            If RunProgram(page$) = #False
                  ;MessageRequester("Attention.",  message$)
                  DisableWindow(#WINDOW_Main, 1)
                  CompilerSelect #PB_Compiler_OS
                        CompilerCase #PB_OS_Windows
                              MessageRequesterPerso(410, 120, "Information.", MRP_OpenNavigateurWait$(), "Trebuchet MS", 10, 18, 0, #MRP_iconeInformation, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                              
                        CompilerCase #PB_OS_Linux
                              MessageRequesterPerso(410, 120, "Information.", MRP_OpenNavigateurWait$(), "FreeSans", 10, 18, 0, #MRP_iconeInformation, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                              
                  CompilerEndSelect
                  DisableWindow(#WINDOW_Main, 0)
                  StickyWindow(#WINDOW_Main, 1)
                  StickyWindow(#WINDOW_Main, 0)
            EndIf
      CompilerElse
            If RunProgram("xdg-open", page$, "") = #False
                  browser$ = Trim(GetEnvironmentVariable("BROWSER"))
                  If browser$ = ""
                        If RunProgram("gnome-open", page$, "") = #False
                              If RunProgram("kfmclient","exec "+ page$, "") = #False
                                    If RunProgram("www-browser", page$, "") = #False
                                          ;MessageRequester("Attention.",  message$)
                                          DisableWindow(#WINDOW_Main, 1)
                                          CompilerSelect #PB_Compiler_OS
                                                CompilerCase #PB_OS_Windows
                                                      MessageRequesterPerso(410, 120, "Information.", MRP_OpenNavigateurWait$(), "Trebuchet MS", 10, 18, 0, #MRP_iconeInformation, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                                                      
                                                CompilerCase #PB_OS_Linux
                                                      MessageRequesterPerso(410, 120, "Information.", MRP_OpenNavigateurWait$(), "FreeSans", 10, 18, 0, #MRP_iconeInformation, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                                                      
                                          CompilerEndSelect
                                          DisableWindow(#WINDOW_Main, 0)
                                          StickyWindow(#WINDOW_Main, 1)
                                          StickyWindow(#WINDOW_Main, 0)
                                    EndIf
                              EndIf
                        EndIf
                  Else
                        If RunProgram(browser$,page$,"") = #False
                              ;MessageRequester("Attention.",  message$)
                              DisableWindow(#WINDOW_Main, 1)
                              CompilerSelect #PB_Compiler_OS
                                    CompilerCase #PB_OS_Windows
                                          MessageRequesterPerso(410, 120, "Information.", MRP_OpenNavigateurWait$(), "Trebuchet MS", 10, 18, 0, #MRP_iconeInformation, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                                          
                                    CompilerCase #PB_OS_Linux
                                          MessageRequesterPerso(410, 120, "Information.", MRP_OpenNavigateurWait$(), "FreeSans", 10, 18, 0, #MRP_iconeInformation, "OK", #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
                                          
                              CompilerEndSelect
                              DisableWindow(#WINDOW_Main, 0)
                              StickyWindow(#WINDOW_Main, 1)
                              StickyWindow(#WINDOW_Main, 0)
                        EndIf
                  EndIf
            EndIf
      CompilerEndIf
EndProcedure
; IDE Options = PureBasic 4.60 RC 1 (Windows - x64)
; CursorPosition = 871
; FirstLine = 851
; Folding = --
; Markers = 85,155,586
; EnableXP
; Executable = MRP.exe