XIncludeFile("libRequesterPerso.pbi")

; -------------------------------------------------------------------------------------------
;- Enumerations.
; -------------------------------------------------------------------------------------------
Enumeration #PB_Compiler_EnumerationValue
      #WINDOW_Main
      
      #STATUT_BAR
      
      #MENU_WindowMain
      #MENU_Quitter
      #MENU_Importer
      #MENU_ValeursParDefaut
      #MENU_Site
      #MENU_APropos
      
      #FRAME3D_ProprieteFenetre
      #TEXT_NomFenetre
      #STRING_NomFenetre
      #BUTTON_IMAGE_NomFenetreHelp
      #TEXT_NomNewList
      #STRING_NomNewList
      #BUTTON_IMAGE_NomNewListHelp
      #TEXT_Width
      #STRING_Width
      #TEXT_Height
      #STRING_Height
      #TEXT_LesBoutons
      #COMBO_BOX_LesBoutons
      
      #FRAME3D_Icone
      #BUTTON_IMAGE_Exclamation
      #BUTTON_IMAGE_Info
      #BUTTON_IMAGE_Interrogation
      #BUTTON_IMAGE_Stop
      #BUTTON_AucuneImage
      #TEXT_IconeChoisie
      #IMAGE_IconeChoisieResultat
      
      #FRAME3D_ProprieteTexte
      #TEXT_Police
      #COMBO_BOX_Police
      #TEXT_PoliceTaille
      #COMBO_BOX_PoliceTaille
      #TEXT_HauteurDeLigne
      #SPIN_HauteurDeLigne
      #BUTTON_IMAGE_HauteurDeLigneHelp
      #CHECK_BOX_Debug
      #BUTTON_IMAGE_DebugHelp
      
      #EDITOR_MessageRequester
      
      #TEXT_Modal
      #STRING_Modal
      
      #BUTTON_Tester
      #BUTTON_Generer
      
      #IMAGE_iconeQuit
      #IMAGE_iconeImport
      #IMAGE_iconeDefaut
      #IMAGE_iconeUrl
      #IMAGE_iconeAPropos
      
      #IMAGE_iconeExclamation
      #IMAGE_iconeInformation
      #IMAGE_iconeQuestion
      #IMAGE_iconeError
      #IMAGE_iconeAucune
      
      #IMAGE_imageHelp_NNLH
      #IMAGE_imageHelp_HDL
      #IMAGE_imageHelp_DH
EndEnumeration


; -------------------------------------------------------------------------------------------
;- Fonts.
; -------------------------------------------------------------------------------------------
Global fontIdTrebuchet8, fontIdTrebuchet10

CompilerSelect #PB_Compiler_OS 
      CompilerCase #PB_OS_Windows 
            fontIdTrebuchet8  = LoadFont (#PB_Any, "Trebuchet MS", 8)
            fontIdTrebuchet10 = LoadFont (#PB_Any, "Trebuchet MS", 10)
            
      CompilerCase #PB_OS_Linux  ; Sans  Monospace
            fontIdTrebuchet8  = LoadFont (#PB_Any, "FreeSans", 8)
            fontIdTrebuchet10 = LoadFont (#PB_Any, "FreeSans", 10)
            
CompilerEndSelect


; -------------------------------------------------------------------------------------------
;- Structures.
; -------------------------------------------------------------------------------------------
Structure sMessageRequester
      Width.i
      Height.i
      IdImage.i
      ModeDebug.b
      PoliceNom$
      PoliceTaille.b
      HauteurDeLigne.b
      NomFenetre$
      NomNewList$
      BoutonsActions$
      Modal$
EndStructure


; -------------------------------------------------------------------------------------------
;- Variables.
; -------------------------------------------------------------------------------------------
Global Open_MessageRequester.sMessageRequester
Global flags.i = #PB_Window_TitleBar | #PB_Window_ScreenCentered
Global flags$ = "#PB_Window_TitleBar | #PB_Window_ScreenCentered"

Global iconeAvertissement$ = "#MRP_iconeAucune"

Global evenement.i, quit.i
Global policeWindows$ = "Trebuchet MS", policeLinux$ = "FreeSans"


; -------------------------------------------------------------------------------------------
;- Declare.
; -------------------------------------------------------------------------------------------
Declare MessageRequesterBuild()
Declare MessageRequesterTester()
Declare MessageRequesterSauvegarder()
Declare MessageRequesterValeursParDefaut()
Declare MessageRequesterImporter()
Declare OuvrirNavigateurParDefaut(page$)


; -------------------------------------------------------------------------------------------
;- Images incrustes en ressources.
; -------------------------------------------------------------------------------------------
DataSection
      iconeQuit:
      IncludeBinary "imagesPersos"+ #SeparatorDir +"Quit.png"
      iconeImport:
      IncludeBinary "imagesPersos"+ #SeparatorDir +"Import.png"
      iconeDefaut:
      IncludeBinary "imagesPersos"+ #SeparatorDir +"Defaut.png"
      iconeUrl:
      IncludeBinary "imagesPersos"+ #SeparatorDir +"Url.png"
      iconeAPropos:
      IncludeBinary "imagesPersos"+ #SeparatorDir +"APropos.png"
EndDataSection


; -------------------------------------------------------------------------------------------
;- NewList.
; -------------------------------------------------------------------------------------------
Global NewList MRP_NomNewList$()
AddElement(MRP_NomNewList$()) : MRP_NomNewList$() = "Mettre ici le nom de la NewList sans mettre les parenthses."
AddElement(MRP_NomNewList$()) : MRP_NomNewList$() = ""
AddElement(MRP_NomNewList$()) : MRP_NomNewList$() = "Ex : MRP_NomNewList"
AddElement(MRP_NomNewList$()) : MRP_NomNewList$() = "Crera une NewList de ce type :"
AddElement(MRP_NomNewList$()) : MRP_NomNewList$() = ""
AddElement(MRP_NomNewList$()) : MRP_NomNewList$() = "NewList MRP_NomNewList$()"
AddElement(MRP_NomNewList$()) : MRP_NomNewList$() = "AddElement(MRP_NomNewList$()) : MRP_NomNewList$() = "+ Chr(34) +"Ceci est un petit message"+ Chr(34) +""
AddElement(MRP_NomNewList$()) : MRP_NomNewList$() = "AddElement(MRP_NomNewList$()) : MRP_NomNewList$() = "+ Chr(34) +"pour ma MessageRequesterPerso."+ Chr(34) +""

Global NewList MRP_HauteurDeLigne$()
AddElement(MRP_HauteurDeLigne$()) : MRP_HauteurDeLigne$() = "En modifiant la police ou en augmentant sa taille,"
AddElement(MRP_HauteurDeLigne$()) : MRP_HauteurDeLigne$() = "il se peut que les lignes se chevauchent et que"
AddElement(MRP_HauteurDeLigne$()) : MRP_HauteurDeLigne$() = "le pied de certaines lettres soit tronqu."
AddElement(MRP_HauteurDeLigne$()) : MRP_HauteurDeLigne$() = ""
AddElement(MRP_HauteurDeLigne$()) : MRP_HauteurDeLigne$() = "C'est pour cela qu'il peut tre ncessaire d'augmenter"
AddElement(MRP_HauteurDeLigne$()) : MRP_HauteurDeLigne$() = "la hauteur de ligne."

Global NewList MRP_ActiverModeDebug$()
AddElement(MRP_ActiverModeDebug$()) : MRP_ActiverModeDebug$() = "Le mode "+ Chr(34) +"Debug"+ Chr(34) +" permet d'ajouter une bordure autour du texte pour"
AddElement(MRP_ActiverModeDebug$()) : MRP_ActiverModeDebug$() = "vrifier qu'en fonction de la longueur du texte, de sa taille, de sa"
AddElement(MRP_ActiverModeDebug$()) : MRP_ActiverModeDebug$() = "police et de la largeur de la fentre, que le texte n'est pas tronqu."

Global NewList MRP_RemettreValeurParDefaut$()
AddElement(MRP_RemettreValeurParDefaut$()) : MRP_RemettreValeurParDefaut$() = "Vous tes sur le point de remettre les valeurs par dfaut."
AddElement(MRP_RemettreValeurParDefaut$()) : MRP_RemettreValeurParDefaut$() = "Toutes les proprits actuelles seront perdus."
AddElement(MRP_RemettreValeurParDefaut$()) : MRP_RemettreValeurParDefaut$() = ""
AddElement(MRP_RemettreValeurParDefaut$()) : MRP_RemettreValeurParDefaut$() = "Voulez-vous continuer ?"

Global NewList MRP_FichierPrefsExisteDeja$()
AddElement(MRP_FichierPrefsExisteDeja$()) : MRP_FichierPrefsExisteDeja$() = "Le fichier "+ Chr(34) +".prefs"+ Chr(34) +" contenant les proprits"
AddElement(MRP_FichierPrefsExisteDeja$()) : MRP_FichierPrefsExisteDeja$() = "de ce MessageRequesterPerso existe dj."
AddElement(MRP_FichierPrefsExisteDeja$()) : MRP_FichierPrefsExisteDeja$() = ""
AddElement(MRP_FichierPrefsExisteDeja$()) : MRP_FichierPrefsExisteDeja$() = "Voulez-vous craser le fichier pour conserver"
AddElement(MRP_FichierPrefsExisteDeja$()) : MRP_FichierPrefsExisteDeja$() = "les nouvelles valeurs ?"

Global NewList MRP_FichierPrefsExistePasEncore$()
AddElement(MRP_FichierPrefsExistePasEncore$()) : MRP_FichierPrefsExistePasEncore$() = "Le fichier "+ Chr(34) +".prefs"+ Chr(34) +" contenant les proprits"
AddElement(MRP_FichierPrefsExistePasEncore$()) : MRP_FichierPrefsExistePasEncore$() = "de ce MessageRequesterPerso n'existe pas encore."
AddElement(MRP_FichierPrefsExistePasEncore$()) : MRP_FichierPrefsExistePasEncore$() = ""
AddElement(MRP_FichierPrefsExistePasEncore$()) : MRP_FichierPrefsExistePasEncore$() = "Voulez-vous sauvegarder le fichier pour conserver"
AddElement(MRP_FichierPrefsExistePasEncore$()) : MRP_FichierPrefsExistePasEncore$() = "ses valeurs ?"

Global NewList MRP_FichierPrefsSaveFail$()
AddElement(MRP_FichierPrefsSaveFail$()) : MRP_FichierPrefsSaveFail$() = "Le fichier "+ Chr(34) +".prefs"+ Chr(34) +" contenant les proprits de ce"
AddElement(MRP_FichierPrefsSaveFail$()) : MRP_FichierPrefsSaveFail$() = "MessageRequesterPerso n'a pas pu tre sauvegard."
AddElement(MRP_FichierPrefsSaveFail$()) : MRP_FichierPrefsSaveFail$() = ""
AddElement(MRP_FichierPrefsSaveFail$()) : MRP_FichierPrefsSaveFail$() = "Veuillez recommencer."

Global NewList MRP_CodeDansPressePapier$()
AddElement(MRP_CodeDansPressePapier$()) : MRP_CodeDansPressePapier$() = "Le code  t copi dans le presse-papier."

Global NewList MRP_APropos$()
AddElement(MRP_APropos$()) : MRP_APropos$() = "Remerciement :"
AddElement(MRP_APropos$()) : MRP_APropos$() = ""
AddElement(MRP_APropos$()) : MRP_APropos$() = "================================================"
AddElement(MRP_APropos$()) : MRP_APropos$() = ""+ Chr(34) +"Silk icon set"+ Chr(34) +" de Mark james pour ses icnes miniatures."
AddElement(MRP_APropos$()) : MRP_APropos$() = "Son site : http://www.famfamfam.com/lab/icons/silk/"
AddElement(MRP_APropos$()) : MRP_APropos$() = "================================================"

Global NewList MRP_ImportationImpossible$()
AddElement(MRP_ImportationImpossible$()) : MRP_ImportationImpossible$() = "Impossible d'importer le fichier."
; IDE Options = PureBasic 4.60 Beta 4 (Windows - x64)
; CursorPosition = 3
; EnableXP