;CallDebugger
CompilerSelect #PB_Compiler_OS 
      CompilerCase #PB_OS_Windows : #SeparatorDir = "\"
      CompilerCase #PB_OS_Linux      : #SeparatorDir = "/"
CompilerEndSelect

If InitSound() = 0
      MessageRequester("Error", "Can't open DirectX 7 or no sound card is available",  0)
      ;End
EndIf
UseOGGSoundDecoder()

Enumeration
      #son
EndEnumeration

Procedure Open_Window_Main()
      OpenWindow(0, 300, 300, 750, 416, "Windows",  #PB_Window_SystemMenu |  #PB_Window_TitleBar | #PB_Window_ScreenCentered)
      
      Delay(1000)
      
      CatchSound(#son, ?sonError, ?sonErrorEnd - ?sonError)
      PlaySound(#son)
      
      Delay(2000)
      
      CatchSound(#son, ?sonQuestion, ?sonQuestionEnd - ?sonQuestion)
      PlaySound(#son)
      
      Delay(1000)
      End 
EndProcedure
Debug "Adresse sonError = " + Str(?sonError)
Debug "Taille du fichier de donnes = " + Str(?sonErrorEnd - ?sonError)

Debug "Adresse sonQuestion = " + Str(?sonQuestion)
Debug "Taille du fichier de donnes = " + Str(?sonQuestionEnd - ?sonQuestion)


Open_Window_Main()
Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow


DataSection
      sonError : 
      IncludeBinary "sons"+ #SeparatorDir +"sonError.ogg" 
      sonErrorEnd:
      
      sonQuestion:
      IncludeBinary "sons"+ #SeparatorDir +"sonQuestion.ogg"
      sonQuestionEnd:
EndDataSection


; IDE Options = PureBasic 4.60 Beta 3 (Windows - x64)
; CursorPosition = 29
; FirstLine = 5
; Folding = -
; EnableXP